/*  Copyright (C) 1993   Marc Stern  (internet: stern@mble.philips.be)  */

#include <dos.h>
#include <direct.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include "tools.h"

/*
 * Functions    : filedel
 *
 * Description  : Like 'unlink' but allows wildcards
 *
 * Remarks      : Change to target directory to delete files
 *                and come back to current one.
 *
 * Return       :  none
 *
 */

void filedel( const char *filename )

{ struct fcb Fcb;
  union REGS regs;
  struct SREGS sregs;
  char *ptr, *ptr2;
  char curdir[_MAX_PATH] = " :/";


  if ( filename[1] == ':' ) Fcb.fcb_drive = toupper( *filename ) - 'A' + 1;
                       else Fcb.fcb_drive = getdisk();

  ptr = max( strrchr(filename, '\\'), strrchr(filename, '/') );

  if ( ptr ) { int result;
               char tmp;
               *curdir = Fcb.fcb_drive + 'A' - 1;
               getcurdir( Fcb.fcb_drive, curdir + 3 );
               tmp = *++ptr;
               *ptr = '\0';
               result = chdir( filename );
               *ptr = tmp;
               if ( result ) return;
             }

  memset( Fcb.fcb_name, ' ', 11 );
  ptr2 = Fcb.fcb_name;
  while ( *ptr && (*ptr != '.') ) *ptr2++ = *ptr++;
  ptr2 = Fcb.fcb_ext;
  if ( *ptr++ )
     while ( *ptr ) *ptr2++ = *ptr++;

        /*
        DOS Interrupt 13H
        Input:  DS:DX = pointer to fcb
        */

  sregs.ds  = FP_SEG( &Fcb );
  regs.x.dx = FP_OFF( &Fcb );
  regs.h.ah = 0x13;
  intdosx( &regs, &regs, &sregs );

  if ( *curdir != ' ' ) chdir( curdir );
}
